Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 3291)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -238,7 +241,6 @@
     USE arrays_3d,                                                             &
         ONLY:  dzw, e, heatflux_output_conversion, nc, nr, p, pt,              &
-               precipitation_amount, prr, q, qc, ql, ql_c, ql_v, qr,           &
-               rho_ocean, s, sa, tend, u, v, vpt, w, zu, zw,                   &
-               waterflux_output_conversion, hyrho, d_exner
+               precipitation_amount, prr, q, qc, ql, ql_c, ql_v, qr, s, tend,  &
+               u, v, vpt, w, zu, zw, waterflux_output_conversion, hyrho, d_exner
 
     USE averaging
@@ -258,5 +260,5 @@
                ibc_uv_b, io_blocks, io_group, land_surface, message_string,    &
                ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz,                          &
-               psolver, section, simulated_time,                               &
+               ocean_mode, psolver, section, simulated_time,                   &
                time_since_reference_point, uv_exposure
 
@@ -284,4 +286,7 @@
                id_var_time_xy, id_var_time_xz, id_var_time_yz, nc_stat,        &
                netcdf_data_format, netcdf_handle_error
+
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_data_output_2d
 
     USE particle_attributes,                                                   &
@@ -940,15 +945,4 @@
                 level_z(nzb+1) = zu(nzb+1)
 
-             CASE ( 'rho_ocean_xy', 'rho_ocean_xz', 'rho_ocean_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rho_ocean
-                ELSE
-                   IF ( .NOT. ALLOCATED( rho_ocean_av ) ) THEN
-                      ALLOCATE( rho_ocean_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      rho_ocean_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   to_be_resorted => rho_ocean_av
-                ENDIF
-
              CASE ( 's_xy', 's_xz', 's_yz' )
                 IF ( av == 0 )  THEN
@@ -960,15 +954,4 @@
                    ENDIF
                    to_be_resorted => s_av
-                ENDIF
-
-             CASE ( 'sa_xy', 'sa_xz', 'sa_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => sa
-                ELSE
-                   IF ( .NOT. ALLOCATED( sa_av ) ) THEN
-                      ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      sa_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   to_be_resorted => sa_av
                 ENDIF
 
@@ -1306,12 +1289,5 @@
 
 !
-!--             Turbulence closure variables
-                IF ( .NOT. found )  THEN
-                   CALL tcm_data_output_2d( av, do2d(av,if), found, grid, mode,&
-                                             local_pf, nzb_do, nzt_do )
-                ENDIF
-
-!
-!--             Microphysics module quantities
+!--             Quantities of other modules
                 IF ( .NOT. found  .AND.  bulk_cloud_model )  THEN
                    CALL bcm_data_output_2d( av, do2d(av,if), found, grid, mode,&
@@ -1319,6 +1295,9 @@
                 ENDIF
 
-!
-!--             Land surface model quantity
+                IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
+                   CALL gust_data_output_2d( av, do2d(av,if), found, grid,     &
+                                             local_pf, two_d, nzb_do, nzt_do )
+                ENDIF
+
                 IF ( .NOT. found  .AND.  land_surface )  THEN
                    CALL lsm_data_output_2d( av, do2d(av,if), found, grid, mode,&
@@ -1326,6 +1305,9 @@
                 ENDIF
 
-!
-!--             Radiation quantity
+                IF ( .NOT. found  .AND.  ocean_mode )  THEN
+                   CALL ocean_data_output_2d( av, do2d(av,if), found, grid,    &
+                                              mode, local_pf, nzb_do, nzt_do )
+                ENDIF
+
                 IF ( .NOT. found  .AND.  radiation )  THEN
                    CALL radiation_data_output_2d( av, do2d(av,if), found, grid,&
@@ -1334,13 +1316,9 @@
                 ENDIF
 
-!
-!--             Gust module quantities
-                IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
-                   CALL gust_data_output_2d( av, do2d(av,if), found, grid,     &
-                                             local_pf, two_d, nzb_do, nzt_do )
-                ENDIF
-
-!
-!--             UV exposure model quantity
+                IF ( .NOT. found )  THEN
+                   CALL tcm_data_output_2d( av, do2d(av,if), found, grid, mode,&
+                                             local_pf, nzb_do, nzt_do )
+                ENDIF
+
                 IF ( .NOT. found  .AND.  uv_exposure )  THEN
                    CALL uvem_data_output_2d( av, do2d(av,if), found, grid,     &
@@ -1349,5 +1327,5 @@
 
 !
-!--             User defined quantity
+!--             User defined quantities
                 IF ( .NOT. found )  THEN
                    CALL user_data_output_2d( av, do2d(av,if), found, grid,     &
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 3291)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -208,6 +211,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, nc, nr, p, pt, prr, q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, &
-               sa, tend, u, v, vpt, w, d_exner
+        ONLY:  d_exner, e, nc, nr, p, pt, prr, q, qc, ql, ql_c, ql_v, qr, s,   &
+               tend, u, v, vpt, w
 
     USE averaging
@@ -225,5 +228,5 @@
         ONLY:  air_chemistry, do3d, do3d_no, do3d_time_count,                  &
                io_blocks, io_group, land_surface, message_string,              &
-               ntdim_3d, nz_do3d,  plant_canopy,                               &
+               ntdim_3d, nz_do3d,  ocean_mode, plant_canopy,                   &
                psolver, simulated_time, time_since_reference_point,            &
                urban_surface, varnamelength
@@ -252,4 +255,7 @@
                netcdf_data_format, netcdf_handle_error
         
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_data_output_3d
+
     USE particle_attributes,                                                   &
         ONLY:  grid_particles, number_of_particles, particles,                 &
@@ -614,15 +620,4 @@
              ENDIF
 
-          CASE ( 'rho_ocean' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rho_ocean
-             ELSE
-                IF ( .NOT. ALLOCATED( rho_ocean_av ) ) THEN
-                   ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   u_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => rho_ocean_av
-             ENDIF
-
           CASE ( 's' )
              IF ( av == 0 )  THEN
@@ -634,15 +629,4 @@
                 ENDIF
                 to_be_resorted => s_av
-             ENDIF
-
-          CASE ( 'sa' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => sa
-             ELSE
-                IF ( .NOT. ALLOCATED( sa_av ) ) THEN
-                   ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   sa_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => sa_av
              ENDIF
 
@@ -701,12 +685,6 @@
           CASE DEFAULT
 
-             IF ( .NOT. found )  THEN
-                CALL tcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
-                                         nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-!
-!--          Microphysic module quantities
+!
+!--          Quantities of other modules
              IF ( .NOT. found  .AND.  bulk_cloud_model )  THEN
                 CALL bcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
@@ -715,6 +693,16 @@
              ENDIF
 
-!
-!--          Land surface quantity
+             IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                CALL chem_data_output_3d( av, do3d(av,if), found,              &
+                                          local_pf, fill_value, nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
+             IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
+                CALL gust_data_output_3d( av, do3d(av,if), found, local_pf,    &
+                                          nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
              IF ( .NOT. found  .AND.  land_surface )  THEN
 !
@@ -742,6 +730,16 @@
              ENDIF
 
-!
-!--          Radiation quantity
+             IF ( .NOT. found  .AND.  ocean_mode )  THEN
+                CALL ocean_data_output_3d( av, do3d(av,if), found, local_pf,   &
+                                           nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
+             IF ( .NOT. found  .AND.  plant_canopy )  THEN
+                CALL pcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
+                                         fill_value, nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
              IF ( .NOT. found  .AND.  radiation )  THEN
                 CALL radiation_data_output_3d( av, do3d(av,if), found,         &
@@ -750,30 +748,12 @@
              ENDIF
 
-!
-!--          Gust module quantities
-             IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
-                CALL gust_data_output_3d( av, do3d(av,if), found, local_pf,    &
-                                          nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-!
-!--          Chemistry model output
-             IF ( .NOT. found  .AND.  air_chemistry )  THEN
-                CALL chem_data_output_3d( av, do3d(av,if), found,              &
-                                          local_pf, fill_value, nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-!
-!--          Plant canopy model output
-             IF ( .NOT. found  .AND.  plant_canopy )  THEN
-                CALL pcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
-                                         fill_value, nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-!
-!--          User defined quantity
+             IF ( .NOT. found )  THEN
+                CALL tcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
+                                         nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
+!
+!--          User defined quantities
              IF ( .NOT. found )  THEN
                 CALL user_data_output_3d( av, do3d(av,if), found, local_pf,    &
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 3291)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -296,8 +299,8 @@
                 dt_3d, humidity, initializing_actions, land_surface,           &
                 large_scale_forcing, large_scale_subsidence, max_pr_user,      &
-                message_string, neutral, ocean, passive_scalar, simulated_time,&
-                simulated_time_at_begin, use_subsidence_tendencies,            &
-                use_surface_fluxes, use_top_fluxes, ws_scheme_mom,             &
-                ws_scheme_sca
+                message_string, neutral, ocean_mode, passive_scalar,           &
+                simulated_time, simulated_time_at_begin,                       &
+                use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
+                ws_scheme_mom, ws_scheme_sca
         
     USE cpulog,                                                                &
@@ -432,5 +435,5 @@
 !--       According to the Neumann bc for the horizontal velocity components,
 !--       the corresponding fluxes has to satisfiy the same bc.
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              sums_us2_ws_l(nzt+1,:) = sums_us2_ws_l(nzt,:)
              sums_vs2_ws_l(nzt+1,:) = sums_vs2_ws_l(nzt,:)
@@ -459,5 +462,5 @@
              sums_l(:,17,i)                        = sums_wspts_ws_l(:,i)      &
                                            * heatflux_output_conversion  ! w*pt*
-             IF ( ocean          ) sums_l(:,66,i)  = sums_wssas_ws_l(:,i) ! w*sa*
+             IF ( ocean_mode     ) sums_l(:,66,i)  = sums_wssas_ws_l(:,i) ! w*sa*
              IF ( humidity       ) sums_l(:,49,i)  = sums_wsqs_ws_l(:,i)       &
                                            * waterflux_output_conversion  ! w*q*
@@ -490,5 +493,5 @@
 !
 !--    Horizontally averaged profile of salinity
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           !$OMP DO
           DO  i = nxl, nxr
@@ -563,5 +566,5 @@
              sums_l(:,2,0) = sums_l(:,2,0) + sums_l(:,2,i)
              sums_l(:,4,0) = sums_l(:,4,0) + sums_l(:,4,i)
-             IF ( ocean )  THEN
+             IF ( ocean_mode )  THEN
                 sums_l(:,23,0) = sums_l(:,23,0) + sums_l(:,23,i)
              ENDIF
@@ -592,5 +595,5 @@
        CALL MPI_ALLREDUCE( sums_l(nzb,4,0), sums(nzb,4), nzt+2-nzb, MPI_REAL,  &
                            MPI_SUM, comm2d, ierr )
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
           CALL MPI_ALLREDUCE( sums_l(nzb,23,0), sums(nzb,23), nzt+2-nzb,       &
@@ -623,5 +626,5 @@
        sums(:,2) = sums_l(:,2,0)
        sums(:,4) = sums_l(:,4,0)
-       IF ( ocean )  sums(:,23) = sums_l(:,23,0)
+       IF ( ocean_mode )  sums(:,23) = sums_l(:,23,0)
        IF ( humidity ) THEN
           sums(:,44) = sums_l(:,44,0)
@@ -648,5 +651,5 @@
 !
 !--    Salinity
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           sums(:,23) = sums(:,23) / ngp_2dh_s_inner(:,sr)
           hom(:,1,23,sr) = sums(:,23)             ! sa
@@ -930,5 +933,5 @@
 !
 !--             Salinity flux w"sa"
-                IF ( ocean )  THEN
+                IF ( ocean_mode )  THEN
                    sums_l(k,65,tn) = sums_l(k,65,tn)                           &
                                          - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
@@ -1000,5 +1003,5 @@
                          sums_l(k+ki,61,tn) = sums_l(k+ki,61,tn) + &
                                     0.0_wp * rmask(j,i,sr)        ! v"pt"
-                         IF ( ocean )  THEN
+                         IF ( ocean_mode )  THEN
                             sums_l(k+ki,65,tn) = sums_l(k+ki,65,tn) + &
                                        surf_def_h(l)%sasws(m) * rmask(j,i,sr)  ! w"sa"
@@ -1053,5 +1056,5 @@
                    sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
                                     0.0_wp * rmask(j,i,sr)        ! v"pt"
-                   IF ( ocean )  THEN
+                   IF ( ocean_mode )  THEN
                       sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
                                        surf_lsm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
@@ -1104,5 +1107,5 @@
                    sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
                                     0.0_wp * rmask(j,i,sr)        ! v"pt"
-                   IF ( ocean )  THEN
+                   IF ( ocean_mode )  THEN
                       sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
                                        surf_usm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
@@ -1276,5 +1279,5 @@
                                     0.0_wp * rmask(j,i,sr)        ! v"pt" 
 
-                IF ( ocean )  THEN
+                IF ( ocean_mode )  THEN
                    sums_l(nzt,65,tn) = sums_l(nzt,65,tn) + &
                                        surf_def_h(2)%sasws(m) * rmask(j,i,sr)  ! w"sa"
@@ -1336,5 +1339,5 @@
 !--             Salinity flux and density (density does not belong to here,
 !--             but so far there is no other suitable place to calculate)
-                IF ( ocean )  THEN
+                IF ( ocean_mode )  THEN
                    IF( .NOT. ws_scheme_sca .OR. sr /= 0 )  THEN
                       pts = 0.5_wp * ( sa(k,j,i)   - hom(k,1,23,sr) +          &
@@ -1562,5 +1565,5 @@
 !
 !--    Density at top follows Neumann condition
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           sums_l(nzt+1,64,tn) = sums_l(nzt,64,tn)
           sums_l(nzt+1,71,tn) = sums_l(nzt,71,tn)
@@ -2032,5 +2035,5 @@
           first = .TRUE.
 
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              DO  k = nzt, nzb+1, -1
                 IF ( first  .AND.  hom(k,1,18,sr) < -1.0E-8_wp )  THEN
@@ -2080,5 +2083,5 @@
           dptdz_threshold = 0.2_wp / 100.0_wp
 
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              DO  k = nzt+1, nzb+5, -1
                 IF ( dptdz(k) > dptdz_threshold  .AND.                         &
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 3291)
+++ palm/trunk/SOURCE/header.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -425,4 +428,8 @@
     USE netcdf_interface,                                                      &
         ONLY:  netcdf_data_format, netcdf_data_format_string, netcdf_deflate
+
+    USE ocean_mod,                                                             &
+        ONLY:  ibc_sa_t, prho_reference, sa_surface, sa_vertical_gradient,     &
+               sa_vertical_gradient_level, sa_vertical_gradient_level_ind
 
     USE particle_attributes,                                                   &
@@ -578,5 +585,5 @@
     ENDIF
     IF ( nested_run )  run_classification = 'nested ' // run_classification(1:63)
-    IF ( ocean )  THEN
+    IF ( ocean_mode )  THEN
        run_classification = 'ocean - ' // run_classification(1:61)
     ELSE
@@ -733,5 +740,5 @@
     IF ( use_upstream_for_tke )  WRITE ( io, 143 )
     IF ( rayleigh_damping_factor /= 0.0_wp )  THEN
-       IF ( .NOT. ocean )  THEN
+       IF ( .NOT. ocean_mode )  THEN
           WRITE ( io, 123 )  'above', rayleigh_damping_height, &
                rayleigh_damping_factor
@@ -815,5 +822,5 @@
 !
 !-- Computational grid
-    IF ( .NOT. ocean )  THEN
+    IF ( .NOT. ocean_mode )  THEN
        WRITE ( io, 250 )  dx, dy
        
@@ -1176,5 +1183,5 @@
     ENDIF
 
-    IF ( ocean )  THEN
+    IF ( ocean_mode )  THEN
        r_lower = 'sa(0)    = sa(1)'
        IF ( ibc_sa_t == 0 )  THEN
@@ -1253,5 +1260,5 @@
           WRITE ( io, 316 )
        ENDIF
-       IF ( ocean  .AND.  constant_top_salinityflux )                          &
+       IF ( ocean_mode  .AND.  constant_top_salinityflux )                          &
           WRITE ( io, 309 )  top_salinityflux
        IF ( humidity       )  WRITE ( io, 315 )
@@ -1412,5 +1419,5 @@
 !-- Initial salinity profile
 !-- Building output strings, starting with surface salinity
-    IF ( ocean )  THEN
+    IF ( ocean_mode )  THEN
        WRITE ( temperatures, '(F6.2)' )  sa_surface
        gradients = '------'
@@ -1895,5 +1902,5 @@
     WRITE ( io, 412 )  TRIM( reference_state )
     IF ( use_single_reference_value )  THEN
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           WRITE ( io, 413 )  prho_reference
        ELSE
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 3291)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3289 2018-09-28 10:23:58Z suehring
 ! Introduce module parameter for number of inflow profiles
 ! 
@@ -549,4 +552,7 @@
     USE netcdf_data_input_mod,                                                 &
         ONLY:  init_3d, netcdf_data_input_init_3d
+
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_init, ocean_init_arrays
     
     USE particle_attributes,                                                   &
@@ -772,23 +778,4 @@
                  s_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
                  s_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#endif
-    ENDIF
-
-    IF ( ocean )  THEN
-#if defined( __nopointer )
-       ALLOCATE( prho(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
-                 rho_ocean(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
-                 sa(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                            &
-                 sa_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
-                 tsa_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#else
-       ALLOCATE( prho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                        &
-                 rho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                         &
-                 sa_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
-                 sa_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
-                 sa_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-       prho => prho_1
-       rho_ocean  => rho_1  ! routines calc_mean_profile and diffusion_e require
-                      ! density to be apointer
 #endif
     ENDIF
@@ -1010,9 +997,6 @@
        s => s_1;  s_p => s_2;  ts_m => s_3
     ENDIF    
-
-    IF ( ocean )  THEN
-       sa => sa_1;  sa_p => sa_2;  tsa_m => sa_3
-    ENDIF
 #endif
+
 !
 !-- Initialize arrays for turbulence closure
@@ -1022,24 +1006,11 @@
     CALL init_surface_arrays
 !
-!-- Allocate microphysics module arrays
-    IF ( bulk_cloud_model )  THEN
-       CALL bcm_init_arrays
-    ENDIF
-!
-!-- Allocate land surface model arrays
-    IF ( land_surface )  THEN
-       CALL lsm_init_arrays
-    ENDIF
-
-!
-!-- Allocate wind turbine model arrays
-    IF ( wind_turbine )  THEN
-       CALL wtm_init_arrays
-    ENDIF
-!
-!-- Allocate gust module arrays
-    IF ( gust_module_enabled )  THEN
-       CALL gust_init_arrays
-    ENDIF
+!-- Allocate arrays for other modules
+    IF ( bulk_cloud_model    )  CALL bcm_init_arrays
+    IF ( gust_module_enabled )  CALL gust_init_arrays
+    IF ( land_surface        )  CALL lsm_init_arrays
+    IF ( ocean_mode          )  CALL ocean_init_arrays
+    IF ( wind_turbine        )  CALL wtm_init_arrays
+    IF ( uv_exposure         )  CALL uvem_init_arrays
 
 !
@@ -1053,9 +1024,4 @@
     IF ( uv_exposure )  THEN
        CALL uvem_init
-    ENDIF
-!
-!-- Allocate uv exposure arrays
-    IF ( uv_exposure )  THEN
-       CALL uvem_init_arrays
     ENDIF
 
@@ -1230,11 +1196,4 @@
           ENDIF
 
-          IF ( ocean )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   sa(:,j,i) = sa_init
-                ENDDO
-             ENDDO
-          ENDIF
 !
 !--       Set velocity components at non-atmospheric / oceanic grid points to 
@@ -1380,11 +1339,4 @@
           ENDIF
 
-          IF ( ocean )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   sa(:,j,i) = sa_init
-                ENDDO
-             ENDDO
-          ENDIF
 !
 !--       Compute initial temperature field and other constants used in case
@@ -1449,11 +1401,4 @@
        hom(:,1,7,:)  = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
 
-
-!
-!--    Store initial salinity profile
-       IF ( ocean )  THEN
-          hom(:,1,26,:)  = SPREAD( sa(:,nys,nxl), 2, statistic_regions+1 )
-       ENDIF
-
        IF ( humidity )  THEN
 !
@@ -1557,9 +1502,4 @@
        ENDIF       
 
-       IF ( ocean )  THEN
-          tsa_m = 0.0_wp
-          sa_p  = sa
-       ENDIF
-       
        CALL location_message( 'finished', .TRUE. )
 
@@ -1810,6 +1750,4 @@
        ENDIF
        IF ( passive_scalar )  s_p  = s
-       IF ( ocean          )  sa_p = sa
-
 !
 !--    Allthough tendency arrays are set in prognostic_equations, they have
@@ -1821,5 +1759,4 @@
        ENDIF
        IF ( passive_scalar )  ts_m  = 0.0_wp
-       IF ( ocean          )  tsa_m = 0.0_wp
 !
 !--    Initialize synthetic turbulence generator in case of restart.
@@ -2241,16 +2178,13 @@
     IF ( dt_dvrp /= 9999999.9_wp )  CALL init_dvrp
 
-    IF ( ocean )  THEN
-!
-!--    Initialize quantities needed for the ocean model
-       CALL init_ocean
-
-    ENDIF
-!
-!--    Initialize quantities for handling cloud physics
-!--    This routine must be called before lpm_init, because
-!--    otherwise, array d_exner, needed in data_output_dvrp (called by
-!--    lpm_init) is not defined.
-    IF ( .NOT. ocean )  THEN
+!
+!-- Initialize quantities needed for the ocean model
+    IF ( ocean_mode )  CALL ocean_init
+
+!
+!-- Initialize quantities for handling cloud physics.
+!-- This routine must be called before lpm_init, becaus otherwise,
+!-- array d_exner, needed in data_output_dvrp (called by lpm_init) is not defined.
+    IF ( .NOT. ocean_mode )  THEN
 
        ALLOCATE( hyp(nzb:nzt+1) )
@@ -2454,5 +2388,6 @@
     rdf_sc = 0.0_wp
     IF ( rayleigh_damping_factor /= 0.0_wp )  THEN
-       IF (  .NOT.  ocean )  THEN
+
+       IF (  .NOT.  ocean_mode )  THEN
           DO  k = nzb+1, nzt
              IF ( zu(k) >= rayleigh_damping_height )  THEN
@@ -2464,4 +2399,7 @@
           ENDDO
        ELSE
+!
+!--       In ocean mode, rayleigh damping is applied in the lower part of the
+!--       model domain
           DO  k = nzt, nzb+1, -1
              IF ( zu(k) <= rayleigh_damping_height )  THEN
@@ -2473,4 +2411,5 @@
           ENDDO
        ENDIF
+
     ENDIF
     IF ( scalar_rayleigh_damping )  rdf_sc = rdf
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 3291)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -359,5 +362,5 @@
                dz_stretch_level_start, ibc_uv_b, message_string,               &
                momentum_advec, number_stretch_level_end,                       &
-               number_stretch_level_start,ocean, psolver, scalar_advec,        &
+               number_stretch_level_start, ocean_mode, psolver, scalar_advec,  &
                topography, use_surface_fluxes
          
@@ -509,5 +512,5 @@
 !
 !-- Define the vertical grid levels
-    IF ( .NOT. ocean )  THEN
+    IF ( .NOT. ocean_mode )  THEN
     
 !
@@ -1293,5 +1296,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc, message_string, ocean
+        ONLY:  bc_lr_cyc, bc_ns_cyc, message_string, ocean_mode
 
     USE indices,                                                               &
@@ -1386,5 +1389,5 @@
 !-- In order to map topography on PALM grid also in case of ocean simulations,
 !-- pre-calculate an offset value.
-    ocean_offset = MERGE( zw(0), 0.0_wp, ocean )
+    ocean_offset = MERGE( zw(0), 0.0_wp, ocean_mode )
 !
 !-- Reference buildings on top of orography. This is not necessary
@@ -1638,5 +1641,5 @@
 !-- Topography input via ASCII format. 
     ELSE
-       ocean_offset     = MERGE( zw(0), 0.0_wp, ocean )
+       ocean_offset     = MERGE( zw(0), 0.0_wp, ocean_mode )
        topo_3d          = IBSET( topo_3d, 0 )
        topo_3d(nzb,:,:) = IBCLR( topo_3d(nzb,:,:), 0 )
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 3291)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -145,5 +148,5 @@
                mask_x_loop, mask_xyz_dimension, mask_y, mask_y_loop, mask_z,   &
                mask_z_loop, max_masks,  message_string, mid,                   &
-               passive_scalar, ocean, varnamelength
+               passive_scalar, ocean_mode, varnamelength
 
 
@@ -412,7 +415,7 @@
 
              CASE ( 'rho_ocean' )
-                IF ( .NOT. ocean )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires ocean = .TRUE.'
+                IF ( .NOT. ocean_mode )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires ocean mode'
                    CALL message( 'init_masks', 'PA0109', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -428,7 +431,7 @@
 
              CASE ( 'sa' )
-                IF ( .NOT. ocean )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
-                        '" requires ocean = .TRUE.'
+                IF ( .NOT. ocean_mode )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires ocean mode'
                    CALL message( 'init_masks', 'PA0109', 1, 2, 0, 6, 0 )
                 ENDIF
